'use strict';

/**
 * @ngdoc function
 * @name fehlerberichtApp.controller:AboutCtrl
 * @description
 * # AboutCtrl
 * Controller of the fehlerberichtApp
 */
angular.module('fehlerberichtApp')
    .controller('OverviewCtrl', function ($scope, $http) {
        var webservice = 'http://rbs06/GlobalCube/Fehlerbericht/app/db.php?';

        $scope.info = [];
        $scope.error = -1;

        $scope.benutzer = window.localStorage.getItem("Benutzer");

        $scope.overview = [];

        $scope.datum = [];
        $scope.kunden = [];

        $scope.current = {
            'kunde' : '',
            'datum': '',
            'fehler': {}
        };

        $scope.Filter = {
            'datum': moment().format('YYYY-MM-DD'),
            'kunde': '',
            'fehler': '1'
        };

        $scope.removeItem = function (index) {
            $scope.Bestellungen = $scope.Bestellungen.splice(index, 1);
        };

        $scope.refresh = function () {
            $http.get(webservice).success(function (data) {
                $scope.overview = data;
                $scope.datum = _.uniq(_.pluck(data, 'datum'));
            });

            $http.get(webservice + 'kunden=1').success(function (data) {
                $scope.kunden = data;
            });
        };

        $scope.importData = function () {
            $http.get('http://rbs06/GlobalCube/Fehlerbericht/app/import.php').success(function (data) {
                if (Array.isArray(data)) {
                    $scope.info = data;
                    if (data.length === 0) {
                        $scope.error = -1;
                    } else {
                        $scope.error = 0;
                        $scope.refresh();
                    }
                } else {
                    $scope.info[0] = data;
                    $scope.error = 1;
                }
            });
        };

        $scope.refresh();

        $scope.minuten = function (t) {
            var faktor, m, mins;
            if (!t) {
                return '';
            }
            faktor = 1;
            if (t < '00:00:00') {
                t = t.substring(1);
                faktor = -1;
            }
            m = moment(t, 'HH:mm:ss');
            mins = faktor * (m.minutes() + m.hours() * 60);
            return mins + " Min.";
        };

        $scope.dateFormat = function (date) {
            var d = moment(date);
            if (d.isValid()) {
                return moment(date).format('DD.MM.YYYY');
            }
            return date;
        };

        $scope.setCurrent = function (zeile) {
            $scope.current.kunde = zeile.kunde;
            $scope.current.datum = zeile.datum;

            $http.get(webservice + 'kunde=' + zeile.kunde + '&datum=' + zeile.datum).success(function (data) {
                $scope.current.fehler = data;
                if (data.benutzer === '') {
                    $scope.current.fehler.benutzer = $scope.benutzer;
                }
            });
        };

        $scope.saveUser = function (name) {
            window.localStorage.setItem("Benutzer", name);
            $scope.benutzer = name;
        };

        $scope.saveComments = function () {
            $http.post(webservice + 'kunde=' + $scope.current.kunde + '&datum=' + $scope.current.datum, $scope.current.fehler).success(function (data) {
                window.alert('Hat geklappt!');
            });
        };
    });